<?php

/*
Plugin Name: OronjoWordpressPlugin
Plugin URI: https://www.oronjo.com/
Description: Automatically populate your Oronjo content into Wordpress
Author: rluitwieler
Version: 3.8
Author URI: http://wordpress.org/extend/plugins/profile/rluitwieler
*/ 

/*  Copyright 2008  Ronald Luitwieler  (email : ro@oronjo.nl)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

$oronjo_domain = 'oronjowordpressplugin';
$oronjo_is_setup = 0;


function save_Oronjo_settings(){
  $option_oronjoid     = $_POST['oronjoid'];
  $option_oronjoapikey = $_POST['oronjoapikey'];
  $option_post_status  = $_POST['post_status'];
  $option_cat_id       = $_POST['cat_id'];
  $option_tag          = $_POST['oronjo_tag'];
  $option_item_count   = $_POST['oronjo_number_of_items'];
  $option_updated_only = $_POST['updated_only'];
  $option_image_tag    = $_POST['use_image_tag'];
  

  update_option('oronjo_oronjoapikey', $option_oronjoapikey);
  update_option('oronjo_post_status', $option_post_status);
  update_option('oronjo_cat_id', $option_cat_id);
  update_option('oronjo_tag', $option_tag);
  update_option('updated_only', $option_updated_only);
  update_option('use_image_tag', $option_image_tag);
  update_option('oronjo_number_of_items', $option_item_count);
};




function Oronjo_subpanel() {
  if (isset($_POST['save_Oronjo_settings'])) {
    save_Oronjo_settings();
    ?> <div class="updated"><p>Oronjo Plugin Settings have been saved. If you would like to import your Oronjo products into Wordpress, hit the 'Import Oronjo Posts' button.</p></div> <?php
  }
  if (isset($_POST['create_Oronjo_posts'])) {
    save_Oronjo_settings();
    ?> <div class="updated"><p>Your Oronjo Content has been imported/updated, check the log at the bottom of the page...</p></div> <?php
  }
	?>


<div class="wrap">
  <h2 style="text-align: center;">
    <a href="https://www.oronjo.com/" target="top">
    <img src="https://oronjo-meteor.s3.amazonaws.com/prod/public/oronjo_blue92.png" alt="Oronjo, Sell Your Content On Your Own Site" align="middle" border="0"></a> Oronjo Plugin Settings
  </h2>

  <form method="post" style="padding-top: 20px;">
    <table>

   <tr valign="top">
     <th scope="row" width="20%" style="text-align: right; padding-right: 20px;">Oronjo API Key</th>
     <td width="25%">
        <input name="oronjoapikey" type="text" id="oronjoapikey" value="<?php echo get_option('oronjo_oronjoapikey'); ?>" size="45" />
     </td> 
     <td width="55%">You can find your <a href="https://www.oronjo.com/account" target="top">Oronjo API Key</a> on your account (tab 'Integrations').</td>
   </tr>
 

   <tr valign="top">
     <th scope="row" style="text-align: right; padding-right: 20px;">Publish Status</th>
     <td>
     <select name="post_status" id="post_status">
     <option <?php if(get_option('oronjo_post_status') == 'publish') { echo 'publish'; } ?> value="publish">Published</option>
     <option <?php if(get_option('oronjo_post_status') == 'draft') { echo 'selected'; } ?> value="draft">Draft</option>
     </select>
     </td> <td>This will be the status of newly imported/updated Oronjo products.</td>
   </tr>

   <tr valign="top">
     <th scope="row" style="text-align: right; padding-right: 20px;">Category</th>
     <td>
     <select name="cat_id" id="cat_id" class='postform'>
     <?php 
     $oronjo_cat_id = get_option('oronjo_cat_id');
     if ($oronjo_cat_id==''){$oronjo_cat_id=1;}
     wp_dropdown_cats(0,$oronjo_cat_id,0,0,0); 
     ?>
     </select>
     </td> <td>Default category of newly imported/updated Oronjo products.</td>
   </tr>



   <tr valign="top">
     <th scope="row" style="text-align: right; padding-right: 20px;">Tag</th>
     <td>
      <input name="oronjo_tag" type="text" id="oronjo_tag" value="<?php echo get_option('oronjo_tag'); ?>" size="45" />
     </td> <td>Default tag of newly imported/updated Oronjo products.</td>
   </tr>
   <tr valign="top">
     <th scope="row" style="text-align: right; padding-right: 20px;"># of Products</th>
     <td>
      <!-- <input name="oronjo_number_of_items" type="text" id="oronjo_number_of_items" value="<?php echo get_option('oronjo_number_of_items'); ?>" size="5" /> -->
     <select name="oronjo_number_of_items" id="oronjo_number_of_items">
     <option <?php if(get_option('oronjo_number_of_items') == '1') { echo 'selected'; } ?> value="1">Import 1 product</option>
     <option <?php if(get_option('oronjo_number_of_items') == '5') { echo 'selected'; } ?> value="5">Import 5 products</option>
     <option <?php if(get_option('oronjo_number_of_items') == '10') { echo 'selected'; } ?> value="10">Import 10 products</option>
     <option <?php if(get_option('oronjo_number_of_items') == '25') { echo 'selected'; } ?> value="25">Import 25 products</option>
     <option <?php if(get_option('oronjo_number_of_items') == '50') { echo 'selected'; } ?> value="50">Import 50 products</option>
     <option <?php if(get_option('oronjo_number_of_items') == '100') { echo 'selected'; } ?> value="100">Import 100 products</option>
     <option <?php if(get_option('oronjo_number_of_items') == 'all')  { echo 'selected'; } ?> value="all">Import all products</option>
     </select>

     </td> 
     <td>Number of products that will be imported/updated each time you hit the 'Import Oronjo Posts' button.</td>
   </tr>

   <tr valign="top">
     <th scope="row" style="text-align: right; padding-right: 20px;">Updated Products</th>
     <td>
      <fieldset>
        <input id="updated_only" name="updated_only" type="checkbox" value="1" <?php checked( get_option( 'updated_only' ) ); ?>> Import updated products only.
      </fieldset>
     </td>
     <td>Process only products that have been updated on Oronjo since the last import run.  If you would like to process all your Oronjo products, leave this checkbox 'unchecked'. </td>
   </tr>

   <tr valign="top">
     <th scope="row" style="text-align: right; padding-right: 20px;">Price Tag</th>
     <td>
      <fieldset>
        <input id="use_image_tag" name="use_image_tag" type="checkbox" value="1" <?php checked( get_option( 'use_image_tag' ) ); ?>> Use image   
      </fieldset>
     </td>
     <td>Check this box if you want to use the Oronjo price tag image. If you prefer a text link, leave this checkbox 'unchecked'.</td>
   </tr>

   <tr valign="top">
     <th scope="row"></th>
     <td style="padding-top: 20px;">
      <input type="submit" name="save_Oronjo_settings" value="Save Settings" class="button button-primary" />
      <input type="submit" name="create_Oronjo_posts" value="Import Oronjo Posts" class="button" />
     </td>
   </tr>

  </table>
  </form>
</div>

<?php
  if (isset($_POST['create_Oronjo_posts'])) {
    echo '	<div class="wrap">';
    create_Oronjo_posts();
    echo '</div>';
  }
?>

<?php } // end Oronjo_subpanel()

function image_tag($productId) {
  return '<a href="https://www.oronjo.com/p/'.$productId.'"><img src="https://www.oronjo.com/live/images/'.$productId.'"></a>';
};
function link_tag($productId, $priceTag) {
  return '<a href="https://www.oronjo.com/p/'.$productId.'">Buy Now for '.$priceTag.'</a>';
};

function create_Oronjo_posts(){
  global $wpdb;
  include_once(ABSPATH . '/wp-config.php');
  include_once(ABSPATH . WPINC . '/wp-db.php');
  $current_user = wp_get_current_user();
  $oronjo_user_id = $current_user->ID;
  $oronjo_oronjoapikey = get_option('oronjo_oronjoapikey');
  $oronjo_api = 'https://www.oronjo.com/api/1';
  $oronjo_tag = get_option('oronjo_tag');
  $post_status = get_option('oronjo_post_status');
  $oronjo_cat_id = get_option('oronjo_cat_id');
  $maxitems = get_option('oronjo_number_of_items');
  $updated_only = get_option('updated_only');

  if ($oronjo_cat_id !='1') {
    $cat = array($oronjo_cat_id);
  }
  echo '<br><hr>';
  echo '<h2>Import Log</h2>';
  echo 'Updating Wordpress with your products from Oronjo!<br>';
  echo 'Oronjo Wordpress posts will be created with a status of '.$post_status.'.<br>';
  echo '<hr>';
  //
  // include_once(ABSPATH . WPINC . '/rss.php');
  // use our local version to avoid standard rss bug...
  // include_once('rss.php');
  // define('MAGPIE_CACHE_ON', false);
  // $rss = fetch_rss($oronjo_api);

  $args = array(
    'headers' => array( "origin" => get_site_url() )
  );
  // Sites._id
  $query = '/?products='.$oronjo_oronjoapikey.'&count='.$maxitems.'&updated_only='.$updated_only;
  $response = wp_remote_get( $oronjo_api.$query, $args );
  $response_code = $response['response']['code'];

  if( $response_code != 200 ) {
     $body = json_decode($response['body']);
      echo '<strong>Oops... There is an error:</strong><br>';
     echo $body->{'error'};
     echo '<br><hr>';
     echo 'Response details:<pre>';
     print_r( $response );
     echo '</pre>';
  } else {
     // echo 'Response:<pre>';
     // print_r( $response );
     // echo '</pre>';
     $body = json_decode($response['body']);
     $sites = $body->{'sites'};
     $site = $sites[0];
     // echo 'Response:<pre>';
     // print_r( $site->products);
     // echo '</pre>';


    $items = $site->products;


    if (empty($items)) {
      echo 'No Oronjo products found that need to be processed.<br><hr>';
    } else { 

     foreach ( $items as $item ) {
       // print_r($item);

       $productId = $item->_id;
       $title = $date = $categories = $content = $post_id = '';
       $title = addslashes(trim($item->name));
       $post_name = sanitize_title($title);
       $date = strtotime($item->updated);
       $post_date = gmdate('Y-m-d H:i:s', $date);
       $categories = $oronjo_cat_id;
       $price = $item->price;
       $currency = $item->currency;
       $price_tag = number_format($price, 2).' '.$currency;
       $content = addslashes(trim($item->description));
       if ($use_image_tag == 1) {
          $content = $content.'<p>'.image_tag($productId).'</p>';
       } else {
          $content = $content.'<p>'.link_tag($productId, $price_tag).'</p>';
        }

       // update or insert?
       $ID = $wpdb->get_var("SELECT post_id FROM $wpdb->postmeta 
                             WHERE  meta_key = 'product._id' 
                             AND    meta_value = '$productId' ");
       if ($ID) {
         echo "Updating.... $title (productId: $productId)<br>";
       } else {
         echo "Inserting... $title <br>";
       }
       echo '<hr>';
 
       // Insert the post into the database
       	$post_values = array(
           'post_status' => $post_status
          ,'post_type' => 'post'
          ,'ID' => $ID
          ,'post_author' => $oronjo_user_id
          ,'post_date' => $post_date
          ,'post_date_gmt' => $post_date
          ,'comment_status' => get_option('default_comment_status')
          ,'post_category' => $cat
          ,'tags_input' => $oronjo_tag
          ,'ping_status' => get_option('default_ping_status')
          ,'post_parent' => 0
          ,'menu_order' => 0
          ,'to_ping' =>  ''
          ,'pinged' => ''
          ,'post_password' => ''
          ,'post_title' => $title
          ,'post_content' => $content
          ,'post_content_filtered' => ''
          ,'post_excerpt' => ''
         );

        // print_r($post_values);
        $postId = wp_insert_post($post_values); 
        if (!$ID) {
          add_post_meta( $postId, 'product._id', $productId );
        }
     }
   }
 }

 echo 'finished...';
 echo '<hr>';
};

function Oronjo_admin_menu() {
   if (function_exists('add_options_page')) {
     oronjo_setup();
     add_options_page('Oronjo Plugin Settings', 'Oronjo Plugin', 8, basename(__FILE__), 'Oronjo_subpanel');

   }
}

function oronjo_setup()
{
   global $oronjo_domain, $oronjo_is_setup;

   if($oronjo_is_setup) {
      return;
   } 
}

add_action('admin_menu', 'Oronjo_admin_menu'); 
?>